#############################################################################
#                       YOU NEED TO CHANGE BELOW VALUES                     #
#       until you see a note like this saying you don't have to anymore!    #
#############################################################################

# CONFIG FOR MAPDEV VERSION 0.5

# By default the mapdirectory for autoload with the console.
# This is the (system) command thats run and showed in the console on startup!
# Disabled = our $initcmd = "";     => Will show blank "console" at startup.
# NOTE: You must use double \\ for this variable!
our $initcmd = "dir C:\\WolfDev\\etmain\\maps\\";           # Change if you want 

# Location of GTK RADIANT 1.5
# (program will still work if not specified, just wont launch this when asked)
# NOTE: You must use double \\ for this variable!           # MUST CHANGE, probably
our $radex15   = ("C:\\Program Files (x86)\\GtkRadiant 1.5.0\\GtkRadiant.exe");

# Location of GTK RADIANT 1.4
# (program will still work if not specified, just wont launch this when asked)
# NOTE: You must use double \\ for this variable!           # MUST CHANGE, probably
our $radex14   = ("C:\\Program Files\\GtkRadiant-1.4\\GtkRadiant-1.4.0.exe");

# Configuration
# Change this to your game.
# Alternatives: <quake3|wolf|et|etut|ef|jk2|ja|sof2|tenebrae|qfusion>
our $game    = "et";

# Change this to your game dir. e.g. C:/WolfDev/
# (The directory where ET.exe is, and it must be a "/" (trailing slash) at the end)
# NOTE: Seperate installations for playing and mapping is always recommended.
our $gamedir = "C:/WolfDev/";           # MUST CHANGE

# Change these below to the configs you want your server\game to load on startup.
# NOTE: This is etpro\configs\file.config configs, not server.cfg configs, aka only for use with ETPRO.
# +config dinidev
our $config  = "+config dinidev";       # MUST CHANGE

# Player .cfg file  
# Dinius.cfg 
our $playerconfig   = "Dinius";         # MUST CHANGE

# Server .cfg file
# Server.cfg
our $serverconfig   = "server";         # MUST CHANGE


#############################################################################
#       YOU DO NOT NEED TO CHANGE THE BELOW VALUES, UNLESS YOU WANT TO!     #
#############################################################################
# Directories
# Maybe you need to change these to work with other games.. (e.g. @ q3's 'etmain' => baseq3)
my $basedir     = $gamedir  .   "etmain/";
my $textures    = $basedir  .   "textures/";
my $mapdir      = $basedir  .   "maps/";
my $scripts     = $basedir  .   "scripts/";
my $moddir      = $gamedir  .   "etpro/";
my $backupdir   = $mapdir   .   "backups/";


#############################################################################
# Touch these => Fail,,, unless ofc you know what you're doing server-wise:o
# These arent important to change.
# Name of your Game executable. If $game = et, then no need to change.
our $exe     = "ET.exe";

# Change this to whatever startup parameters you want. Most relevant is changing "+exec Dinius" to the name of YOUR .cfg file!
# MUST END WITH +DEVMAP
our $parm    = "+set fs_basepath $gamedir +set fs_homedir $gamedir +set fs_game etpro +set g_gametype 2 +exec $playerconfig +exec $serverconfig +config $config +devmap";

# Change this to the location of q3map2.exe. Usually the same.
our $q3map2  = "C:/Program Files (x86)/GtkRadiant 1.5.0/q3map2.exe";


#########################################################################
#       CHANGE BELOW SETTINGS FOR CUSTOM Q3MAP2 BUILD PARAMETERS!       #
#########################################################################
# Touch these => Fail,,, unless ofc you know what you're doing q3map2-wise :P
# The initial q3map2 parameters to use for all compilations.
our $initial = "\"$q3map2\" -fs_basepath \"$gamedir\" -game $game";

# NEED TO KEEP \"$mapdir at the end!!!
# "Vis" build button runs $meta and then $vis
# "Light" build button runs $meta, then $vis, then $light
# "Final" build button runs $final_1-3
our $meta    = "$initial -v -meta                       \"$mapdir";
our $vis     = "$initial -v -vis -fast -saveprt         \"$mapdir";
our $light   = "$initial -v -light -fast                \"$mapdir";
our $final_1 = "$initial -v -meta                       \"$mapdir";
our $final_2 = "$initial -v -meta -v -vis -saveprt      \"$mapdir";
our $final_3 = "$initial -v -light                      \"$mapdir";

# Decompile parameters
our $decompile = "$initial -convert -format map \"$mapdir";


# Touch this => Fail,,, Unless ofc you know what you're doing perl-wise^^
1;